package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.shop.entity.UserGrade;
import com.gxwebsoft.shop.param.UserGradeParam;
import com.gxwebsoft.shop.service.UserGradeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 用户会员等级表控制器
 *
 * @author 科技小王子
 * @since 2023-06-20 16:33:06
 */
@Api(tags = "用户会员等级表管理")
@RestController
@RequestMapping("/api/shop/user-grade")
public class UserGradeController extends BaseController {
    @Resource
    private UserGradeService userGradeService;

    @PreAuthorize("hasAuthority('shop:userGrade:list')")
    @OperationLog
    @ApiOperation("分页查询用户会员等级表")
    @GetMapping("/page")
    public ApiResult<PageResult<UserGrade>> page(UserGradeParam param) {
        // 使用关联查询
        return success(userGradeService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userGrade:list')")
    @OperationLog
    @ApiOperation("查询全部用户会员等级表")
    @GetMapping()
    public ApiResult<List<UserGrade>> list(UserGradeParam param) {
        // 使用关联查询
        return success(userGradeService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userGrade:list')")
    @OperationLog
    @ApiOperation("根据id查询用户会员等级表")
    @GetMapping("/{id}")
    public ApiResult<UserGrade> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(userGradeService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:userGrade:save')")
    @OperationLog
    @ApiOperation("添加用户会员等级表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserGrade userGrade) {
        if (userGradeService.save(userGrade)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userGrade:update')")
    @OperationLog
    @ApiOperation("修改用户会员等级表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserGrade userGrade) {
        if (userGradeService.updateById(userGrade)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userGrade:remove')")
    @OperationLog
    @ApiOperation("删除用户会员等级表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userGradeService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:userGrade:save')")
    @OperationLog
    @ApiOperation("批量添加用户会员等级表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserGrade> list) {
        if (userGradeService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userGrade:update')")
    @OperationLog
    @ApiOperation("批量修改用户会员等级表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserGrade> batchParam) {
        if (batchParam.update(userGradeService, "grade_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userGrade:remove')")
    @OperationLog
    @ApiOperation("批量删除用户会员等级表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userGradeService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
